#include<bits/stdc++.h>
using namespace std;

const int maxn=2003;
int n, s;
int a[maxn];
int dp[maxn][20003];

int main(){
cin>>s>>n;

for(int i=0; i<n; i++){
    dp[i][0]=0;
}

for(int i=0; i<n; i++){
    cin>>a[i];
}
sort(a, a+n);

for(int j=1; j<=s; j++){
    dp[0][j]=j;
}

//cerr<<"sorted"<<endl;
for(int i=1; i<n; i++){
    for(int j=1; j<=s; j++){
        //cerr<<"i="<<i<<" j="<<j<<endl;
        dp[i][j]=dp[i-1][j];
        if(j>=a[i]){
            int p=j/a[i];
            int c=j%a[i];
            dp[i][j]=min(dp[i][j], dp[i-1][c]+p);
        }
        //cerr<<dp[i][j]<<"  ";
    }
    //cerr<<endl;
}
cout<<dp[n-1][s]<<endl;

return 0;
}

